JUCE: MessageThread Class Reference

JUCE

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
MessageThread Class Reference
juce_audio_plugin_client » utility

`#include <juce_LinuxMessageThread.h>`

Inheritance diagram for MessageThread:

## Public Member Functions
| MessageThread ()
| ~MessageThread () override
void | start ()
void | stop ()
bool | isRunning () const noexcept
void | run () override
| Must be implemented to perform the thread's actual code.
Public Member Functions inherited from Thread
| Thread (const String &threadName, size_t threadStackSize=0)
| Creates a thread.
virtual | ~Thread ()
| Destructor.
virtual void | run ()=0
| Must be implemented to perform the thread's actual code.
bool | startThread ()
| Attempts to start a new thread with default ('Priority::normal') priority.
bool | startThread (Priority newPriority)
| Attempts to start a new thread with a given priority.
bool | startRealtimeThread (const RealtimeOptions &options)
| Starts the thread with realtime performance characteristics on platforms that support it.
bool | stopThread (int timeOutMilliseconds)
| Attempts to stop the thread running.
bool | isThreadRunning () const
| Returns true if the thread is currently active.
void | signalThreadShouldExit ()
| Sets a flag to tell the thread it should stop.
bool | threadShouldExit () const
| Checks whether the thread has been told to stop running.
bool | waitForThreadToExit (int timeOutMilliseconds) const
| Waits for the thread to stop.
void | addListener (Listener *)
| Add a listener to this thread which will receive a callback when signalThreadShouldExit was called on this thread.
void | removeListener (Listener *)
| Removes a listener added with addListener.
bool | isRealtime () const
| Returns true if this Thread represents a realtime thread.
void | setAffinityMask (uint32 affinityMask)
| Sets the affinity mask for the thread.
bool | wait (int timeOutMilliseconds) const
| Suspends the execution of this thread until either the specified timeout period has elapsed, or another thread calls the notify() method to wake it up.
void | notify () const
| Wakes up the thread.
ThreadID | getThreadId () const noexcept
| Returns the ID of this thread.
const String & | getThreadName () const noexcept
| Returns the name of the thread.

## Additional Inherited Members
Public Types inherited from Thread
enum class | Priority { highest = 2 , high = 1 , normal = 0 , low = -1 , background = -2 }
| The different runtime priorities of non-realtime threads. More...
using | ThreadID = void *
| A value type used for thread IDs.
Static Public Member Functions inherited from Thread
static bool | launch (std::function< void()> functionToRun)
| Invokes a lambda or function on its own thread with the default priority.
static bool | launch (Priority priority, std::function< void()> functionToRun)
| Invokes a lambda or function on its own thread with a custom priority.
static bool | currentThreadShouldExit ()
| Checks whether the current thread has been told to stop running.
static void JUCE_CALLTYPE | setCurrentThreadAffinityMask (uint32 affinityMask)
| Changes the affinity mask for the caller thread.
static void JUCE_CALLTYPE | sleep (int milliseconds)
| Suspends the execution of the current thread until the specified timeout period has elapsed (note that this may not be exact).
static void JUCE_CALLTYPE | yield ()
| Yields the current thread's CPU time-slot and allows a new thread to run.
static ThreadID JUCE_CALLTYPE | getCurrentThreadId ()
| Returns an id that identifies the caller thread.
static Thread *JUCE_CALLTYPE | getCurrentThread ()
| Finds the thread object that is currently running.
static void JUCE_CALLTYPE | setCurrentThreadName (const String &newThreadName)
| Changes the name of the caller thread.
static void | initialiseJUCE (void *jniEnv, void *jContext)
| Initialises the JUCE subsystem for projects not created by the Projucer.
Protected Member Functions inherited from Thread
Priority | getPriority () const
| Returns the current priority of this thread.
bool | setPriority (Priority newPriority)
| Attempts to set the priority for this thread.

## Detailed Description

## Constructor & Destructor Documentation

## ◆ MessageThread()

MessageThread::MessageThread | ( |  | ) |

References start().

## ◆ ~MessageThread()

MessageThread::~MessageThread | ( |  | ) |
| override

References MessageManager::getInstance(), stop(), and MessageManager::stopDispatchLoop().

## Member Function Documentation

## ◆ start()

void MessageThread::start | ( |  | ) |

References Thread::high, Thread::startThread(), and WaitableEvent::wait().

Referenced by MessageThread(), and HostDrivenEventLoop::~HostDrivenEventLoop().

## ◆ stop()

void MessageThread::stop | ( |  | ) |

References Thread::signalThreadShouldExit(), and Thread::stopThread().

Referenced by HostDrivenEventLoop::HostDrivenEventLoop(), and ~MessageThread().

## ◆ isRunning()

bool MessageThread::isRunning | ( |  | ) | const
| noexcept

References Thread::isThreadRunning().

## ◆ run()

void MessageThread::run | ( |  | ) |
| overridevirtual

Must be implemented to perform the thread's actual code.

Remember that the thread must regularly check the threadShouldExit() method whilst running, and if this returns true it should return from the run() method as soon as possible to avoid being forcibly killed.

See also
  threadShouldExit, startThread

Implements Thread.

References dispatchNextMessageOnSystemQueue(), MessageManager::getInstance(), MessageManager::setCurrentThreadAsMessageThread(), WaitableEvent::signal(), Thread::sleep(), and Thread::threadShouldExit().

The documentation for this class was generated from the following file:

- juce_LinuxMessageThread.h